/* TroiaPreview
 * version 0.2 date 2004-09-01
 * Copyright (C) 2003-2004 1stein <1stein@schuermans.info>
 * Copyleft: GNU public license - http://www.gnu.org/copyleft/gpl.html
 */

#ifndef INC_Vector
#define INC_Vector

//a vector
typedef struct _tVector
{
	double X, Y, Z;
} tVector;

//set vector
void SetVector( tVector * pDest, double X, double Y, double Z );

//vector addition
void Add( tVector * pDest, tVector Src1, tVector Src2 );

//vector subtraction
void Sub( tVector * pDest, tVector Src1, tVector Src2 );

//scale a vector
void Scale( tVector * pV, double Factor );

//linear-combine two vectors
void LinearCombine( tVector * pDest, double Factor1, tVector Src1, double Factor2, tVector Src2 );

//length of a vector
double Len( tVector V );

//normalize a vector
void Normalize( tVector * pV );

//scalar product
double ScalarProduct( tVector Vec1, tVector Vec2 );

//angle between two vectors
double VectorAngle( tVector Vec1, tVector Vec2 );

//vector product
void VectorProduct( tVector * pDest, tVector Vec1, tVector Vec2 );

//rotate vector V around vector A
void Rotate( tVector * pV, tVector A, double Angle );

#endif //#ifndef INC_Vector